<?php
/**
 * UD Page Peel System Plugin 
 * @version		$Id: udpagepeel.php 2012-12-13 14:36:54 ffab $
 * @package		Joomla
 * @subpackage  System
 * @since 		1.6 
 * @copyright   Copyright (C) 2011 Uni-deal
 * @license		GNU/GPL v2 or above
 */

defined('_JEXEC') or die;
jimport('joomla.plugin.plugin');

class plgSystemUdPagePeel extends JPlugin {

	/**
	 * Insert Custom Codes, JS, CSS and HTML at their right place in the Rendered HTML body
	 *
	 * @return	boolean
	 */
        
	public function onAfterRender()	{       
	
		// Make sure we are not dealing with admin part of Joomla
		$app = JFactory::getApplication();
		if($app->isAdmin()) {
			return;
		}
		
		// Are we on the default / frontpage ?
		$menu 				= & JSite::getMenu();	
		$frontpage 			= ( $menu->getActive() == $menu->getDefault() ) ? true : false; 
		
		// Get the required params to see if the plugin should display ?
		$target_front 		= $this->params->get('onFrontPage');			
		$target_page 		= $this->params->get('onAllPage');		
		$excludeCompos		= $this->params->get('excludeComponents');
		$excludeTxt			= $this->params->get('excludeAllArticles');
		$excludeFeatured	= $this->params->get('excludeFeatured');		
		$excludeArchive 	= $this->params->get('excludeArchive');	
		$excludeCategories 	= $this->params->get('excludeCategories');
		$excludeCategory	= $this->params->get('excludeCategory');
		$arrayOptions		= $this->params->get('excludeOptions') ? explode(";", $this->params->get('excludeOptions')) : false; 
		$zIndex				= $this->params->get('zIndex');

		// Using Position Tag ?
		$tagToReplace		= $this->params->get('tagToReplace') ? "{udpagepeel}" : "";
		$posType			= $tagToReplace ? "relative" : "absolute";
		
		// Default value
		$displayEffect 		= false;

		// Should we display effect ? Tests are going to general case to specific case
		if ( ( $target_page && $target_front ) || ( $target_page && $frontpage === false ) || ( $target_front && $frontpage === true ) ) {
			
			$displayEffect  		= true;	
			$currentOption 			= JRequest::getCmd("option");
			$this->currentView  	= JRequest::getCmd("view"); 
			
			// Shall we exclude on all articles ? or on non articles ?
			if ( ( $excludeCompos && ($currentOption != "com_content") ) || ( $excludeTxt && ($currentOption == "com_content") ) ) {
				$displayEffect 	= false;
			}
			// OR Exclude ( Categories, Category, Featured or Archive) OR  ( Specific Options )
			elseif ( ( $currentOption == "com_content" ) && ( $excludeFeatured || $excludeArchive || $excludeCategory  || $excludeCategories ) ) {
			
				$item->id	= JRequest::getVar("id");
				$count		= count($Option);
				
				switch ($this->currentView) {
					case 'featured':
						$displayEffect	= $excludeFeatured ? false : true; 									
					break;
					case 'archive':
						$displayEffect	= $excludeArchive ? false : true; 
					break;
					case 'categories':
						$displayEffect	= $excludeCategories ? false : true; 
					break;					
					case 'category':
						if ( $excludeCategory ) {
							$displayEffect 	= false;
						// Exclude selected category							
						} else {
							$displayEffect	= ( plgSystemUdPagePeel::isItemExcluded($this->params->get('excludeCats'),$item->id) ) ? false : true; 															
						}
					break;
					case 'article':
						// Exclude selected article
						if ( !$excludeTxt ) {
							$displayEffect 	= ( plgSystemUdPagePeel::isItemExcluded($this->params->get('excludeArticles'),$item->id) ) ? false : true; 
						}
					break;					
				}
			}	
			// Exclude specific url with specific option	 
			elseif ( $arrayOptions !== false ) {
			
				// get all couple of option and value in a assoc. array
				foreach ($arrayOptions as $arrayOption) {
					if ( !empty ( $arrayOption ) ) {
						$Option[] = explode("=", $arrayOption);
					}
				}			
				
				// browse the array to see if we are on specific url with theses parameters in querystring
				foreach ($Option as $key => $value) {

					if ( JRequest::getCmd($value[0]) == $value[1] ) {
						$displayEffect 	= false;	
					} 
				}	
			}
		}
		
		// if yes... just do it
		if ( $displayEffect ) {
						
			// Get the rest of the plugin Params since they are now needed		
			$image_under    	= $this->params->get('peelImage');		
			$target_url     	= $this->params->get('targetUrl');
			$target_alt     	= $this->params->get('peelAlt');
			$target_method  	= $this->params->get('targetMethod');
			$target_pos  		= $this->params->get('position');	
			$image_over			= JURI::base() ."media/plg_system_udpagepeel/images/";	

			// Little trick to have allways a default picture to show
			if ( $image_under == "image_to_show.png" ) {
				$image_under 	= "media/plg_system_udpagepeel/images/" . $target_pos ."_image_to_show.png";
			}
				
			// Set the effect variable based on the position
			switch ($target_pos) {
				case 'upper_right':
					$horizon		= "right";
					$vertical		= "top";
					$image_over	   .= "upper_right_page_flip.png";
					break;
				case 'upper_left':
					$horizon		= "left";
					$vertical		= "top";			
					$image_over	   .= "upper_left_page_flip.png";								
					break;		
			}		

			// Prepare CSS 
			$udpagepeel_styles = "\n\t" . "<style type= \"text/css\">" . "\n";
			$udpagepeel_styles.= "\t" . '#page-flip { position:'.$posType.'; '.$horizon.':0; '.$vertical.':0; float:'.$horizon.';  }' . "\n";
			$udpagepeel_styles.= "\t" . '#page-flip-image { width:50px; height:52px; z-index:'.$zIndex.'; position:absolute; '.$horizon.':0; '.$vertical.':0; -ms-interpolation-mode:bicubic; }' . "\n";                
			$udpagepeel_styles.= "\t" . '#page-flip-message { width:50px; height:50px; z-index:'.($zIndex-1).'; overflow:hidden; position:'.$posType.'; '.$horizon.':0; '.$vertical.':0; background:url(\''.JURI::base().$image_under.'\') no-repeat '.$horizon.' top; }' . "\n";		                               
			$udpagepeel_styles.= "\t" . "</style>";                                
			
			// Prepare JavaScript
			$udpagepeel_script = "\n\t" . "<script type=\"text/javascript\">" . "\n";
			$udpagepeel_script.= "\t\t" . "(function($,$$) { window.addEvent('domready',function() {" . "\n";
			$udpagepeel_script.= "\t\t\t" . "var flip = $('page-flip');" . "\n";
			$udpagepeel_script.= "\t\t\t" . "var flipImage = $('page-flip-image');" . "\n";
			$udpagepeel_script.= "\t\t\t" . "var flipMessage = $('page-flip-message');" . "\n";
			$udpagepeel_script.= "\t\t\t" . "flip.addEvents({" ."\n";
			$udpagepeel_script.= "\t\t\t" . " mouseenter:function() {" . "\n";
			$udpagepeel_script.= "\t\t\t" . "  $$(flipImage,flipMessage).set('morph',{ duration: 500 }).morph({" . "\n";
			$udpagepeel_script.= "\t\t\t" . "   width: 307," . "\n";
			$udpagepeel_script.= "\t\t\t" . "   height: 319" . "\n";
			$udpagepeel_script.= "\t\t\t" . "  });" . "\n";
			$udpagepeel_script.= "\t\t\t" . " }," . "\n";                           
			$udpagepeel_script.= "\t\t\t" . " mouseleave:function() {" . "\n";
			$udpagepeel_script.= "\t\t\t" . "  flipImage.set('morph',{ duration: 220 }).morph({" . "\n";
			$udpagepeel_script.= "\t\t\t" . "   width: 50," . "\n";
			$udpagepeel_script.= "\t\t\t" . "   height: 52" . "\n";
			$udpagepeel_script.= "\t\t\t" . "  });" . "\n";
			$udpagepeel_script.= "\t\t\t" . "  flipMessage.set('morph',{ duration:200 }).morph({" . "\n";
			$udpagepeel_script.= "\t\t\t" . "   width: 50," . "\n";
			$udpagepeel_script.= "\t\t\t" . "   height: 50" . "\n";
			$udpagepeel_script.= "\t\t\t" . "  });" . "\n";
			$udpagepeel_script.= "\t\t\t" . " }" . "\n";
			$udpagepeel_script.= "\t\t\t" . "});" . "\n";
			$udpagepeel_script.= "\t\t" . "}); })(document.id,$$)" . "\n";
			$udpagepeel_script.= "\t" . "</script>" . "\n\t";                                                                           
			
			// Prepare Html 
			$udpagepeel_html = "\n";
			$udpagepeel_html.= "<div id=\"page-flip\">" . "\n";
			$udpagepeel_html.= "\t" . "<a href=\"".$target_url."\" target=\"".$target_method."\"><img src=\"".$image_over."\" alt=\"".$target_alt."\" id=\"page-flip-image\" /></a>" . "\n";
			$udpagepeel_html.= "\t" . "<div id=\"page-flip-message\"></div>" ."\n";
			$udpagepeel_html.= "</div>";
			
			// Get Full Response body
			$body = JResponse::getBody();
			
			// Insert JS and CSS very close to where they should be :)
			$body = str_replace ("</title>", "</title>".$udpagepeel_styles, $body);               
			$body = str_replace ("</head>", $udpagepeel_script."</head>", $body);
			
			// Insert HTML replacing the position tag or at the end if the body
			if ( $tagToReplace ) {
				$body = str_replace ($tagToReplace, $udpagepeel_html, $body);
			} else {
				$body = str_replace ("</body>", $udpagepeel_html."</body>", $body);
			}
			
			JResponse::setBody($body);
		}
        return true;            
	}
	
	/**
	 * Array compare to see if actual displayed item id must be excluded
	 *
	 * @return	boolean
	 */    
	
	private function isItemExcluded($excludedItems, $itemId){
        
		if(!empty($excludedItems)){
			$excludedItems = explode(',', $excludedItems);
		}
		
		settype($excludedItems, 'array');
		JArrayHelper::toInteger($excludedItems);
		
		if ( in_array($itemId, $excludedItems) ) {
			return true;
		}
		
		return false;
	
	}
}